/*
 * Click nbfs://nbhost/SystemFileSystem/Templates/Licenses/license-default.txt to change this license
 */
package com.jcg.resourcehandler;

import java.io.IOException;
import java.io.FileWriter;


public class ResourceHandler extends FileWriter implements AutoCloseable {

    private final String fileName;

    public ResourceHandler(String fileName) throws IOException {
        super(fileName);
        this.fileName = fileName;
    }

    public String getName() {
        return fileName;
    }

    @Override
    public void close() throws IOException {
        super.close(); // Call the original FileWriter close method
        System.out.println("Closed CloseableFileWriter for: " + this.getName()); // Optional logging
    }

    public static void main(String[] args) throws IOException {
        // Using ResourceHandler with try-with-resources to automatically close file
        try (ResourceHandler writer = new ResourceHandler("javacodegeeks.txt")) {
            writer.write("This is some text to write to the text file.\n");
            writer.flush(); // Flush the data to the underlying stream
        } // writer is automatically closed here
    }
}
